diff --git a/src/backend/utils/cache/relcache.c b/src/backend/utils/cache/relcache.c
index bd6cd4e47b..49751f2ad0 100644
--- a/src/backend/utils/cache/relcache.c
+++ b/src/backend/utils/cache/relcache.c
@@ -1220,7 +1220,11 @@ retry:
 	 * extracting the relation's reloptions.
 	 */
 	if (relation->rd_rel->relhasrules)
+	{
 		RelationBuildRuleLock(relation);
+		if (relation->rd_rules == NULL)
+			relation->rd_rel->relhasrules = false;
+	}
 	else
 	{
 		relation->rd_rules = NULL;
